<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet SYSTEM "ulang://common/photoalbum" [
		<!ENTITY sys-module        'photoalbum'>
		<!ENTITY sys-method-add        'add'>
		<!ENTITY sys-method-edit    'edit'>
		<!ENTITY sys-method-del        'del'>
		<!ENTITY sys-method-list    'lists'>
		<!ENTITY sys-method-acivity     'activity'>

		<!ENTITY sys-type-list        'album'>
		<!ENTITY sys-type-item        'photo'>
		]>


<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xlink="http://www.w3.org/TR/xlink" xmlns:umi="http://www.umi-cms.ru/TR/umi">

	<xsl:template match="field[@type = 'img_file' and @name='photo']" mode="form-modify">
		<xsl:variable name="altname" select="document(concat('upage://', /result/data/page/@parentId))/udata/page/@alt-name" />
		<xsl:variable name="destination-folder">
			<xsl:choose>
				<xsl:when test="not(text())">
					<xsl:value-of select="concat(@destination-folder, '', document(concat('upage://', /result/data/page/@parentId))/udata/page/@link)" />
					
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="@destination-folder" />
				</xsl:otherwise>
			</xsl:choose>			
		</xsl:variable>
		<div class="field file" id="{generate-id()}" name="{@input_name}"
			umi:field-type="{@type}"
			umi:name="{@name}"
			umi:folder="{$destination-folder}"
			umi:file="{@relative-path}">
			<label for="symlinkInput{generate-id()}">
				<span class="label">
					<acronym>
						<xsl:apply-templates select="." mode="sys-tips" />						
						<xsl:value-of select="@title" />						
					</acronym>
					<xsl:apply-templates select="." mode="required_text" />
				</span>
				<span id="fileControlContainer_{generate-id()}">
					
				</span>
			</label>
		</div>
	</xsl:template>	

</xsl:stylesheet>